1   REM THIS PROGRAM IS THE EXERCISE 5.53m AT PAGE 108 OF THE ITALIAN VERSION
2   REM OF "PROGRAMMING IN BASIC" 1ST EDITION, BY BYRON S. GOTTFRIED 
10  REM SIMPSON RULE FOR APPROXIMATING THE DEFINITE INTEGRAL
50  REM FUNCTION (CUSTOMIZE)
60  DEF FNF(X)=EXP(-(X^2))
100 REM ASK FOR LIMITS AND POINTS
110 PRINT "LEFT LIMIT A=";
120 INPUT A
130 PRINT "RIGHT LIMIT B=";
140 INPUT B
145 PRINT "TYPE 0 TO STOP PROCESS."
150 S=0
160 PRINT "HOW MANY POINTS";
170 INPUT N
180 IF N<=0 THEN 400
190 IF N-INT(N/2)*2<>0 THEN 210	' ONLY ODD INTERVALS!
200 N=N+1
210 W=(B-A)/(N-1)		' CALCULATE INTERVAL CONSTANT WIDTH
250 REM CALCULATE
260 FOR X=A TO B-2*W STEP 2*W
270	S=S+(FNF(X)+4*FNF(X+W)+FNF(X+2*W))*W/3
280 NEXT X
290 PRINT USING "AREA =######.#######",S
300 REM ASK FOR NEW NUMBER OF POINTS
310 GOTO 150
400 END


@ The exercise proposed by prof. Gottfried asked for N up to 101 points in the 
interval 0.0-1.0 (thus respectively up to 50 couples of intervals), giving also 
the exact solution, A=0.7468241; I had to insert a PRINT USING to show the full 
precision decimals of the calculated area.

The following is the output of SIMPSN for the proposed points numbers, noting
that the correct result is achived for 29 points (far lower than 101).

SIMPSN        10:56         16-NOV-14    



LEFT LIMIT A= ?0
RIGHT LIMIT B= ?1
TYPE 0 TO STOP PROCESS.
HOW MANY POINTS ?11
AREA =     0.7468249
HOW MANY POINTS ?21
AREA =     0.7468242
HOW MANY POINTS ?31
AREA =     0.7468241
HOW MANY POINTS ?29
AREA =     0.7468241
HOW MANY POINTS ?27
AREA =     0.7468242
HOW MANY POINTS ?0



TIME:  0.02 SECS.

This program can be customizable in line 20, where you can put your own 
function. For new limits A and B, rerun the program.

It's a useful notice observing here that the Simpson rule achieves the exact
solution for the function y=x^3 in only 3 steps (while the Trapezium rule - see
file TRAPEZ.BAS - requires more than 19000 points to achieve a close but not
exact result, though roundoff errors are in action, here).
