1   REM THIS PROGRAM APPEARS AT PAGE 61 OF THE ITALIAN VERSION OF
2   REM "PROGRAMMING IN BASIC" 1ST EDITION, BY BYRON S. GOTTFRIED 
10  REM COMPUTATION OF DEPRECIATION BY THREE DIFFERENT METHODS
20  PRINT "V=";
30  INPUT V
40  PRINT "N=";
50  INPUT N
60  PRINT "I=";
70  INPUT I
80  PRINT
90  ON I GOTO 100,120,140
100 PRINT "STRAIGHT-LINE METHOD"
110 GOTO 150
120 PRINT "DOUBLE DECLINING BALANCE METHOD"
130 GOTO 150
140 PRINT "SUM-OF-THE-YEARS'-DIGITS METHOD"
150 PRINT
160 PRINT "END OF YEAR","DEPRECIATION"," CURRENT VALUE"
170 LET J=0
180 LET D1=V/N
190 LET F1=V/(N*(N+1)/2)
200 LET J=J+1
210 ON I GOTO 300,400,500
215 
300 REM STRAIGHT-LINE METHOD
305 
310 LET V=V-D1
320 PRINT J,D1,V
330 IF J<N THEN 200
340 STOP
345 
400 REM DOUBLE DECLINING BALANCE METHOD
405 
410 LET D2=(2/N)*V
420 LET V=V-D2
430 PRINT J,D2,V
440 IF J<N THEN 200
450 STOP
455 
500 REM SUM-OF-THE-YEAR'S-DIGITS METHOD
505 
510 LET F2=N-J+1
520 LET D3=F1*F2
530 LET V=V-D3
540 PRINT J,D3,V
550 IF J<N THEN 200
560 END

