1   REM THIS PROGRAM IS THE EXERCISE 5.53h AT PAGE 106 OF THE ITALIAN VERSION
2   REM OF "PROGRAMMING WITH BASIC" 1ST EDITION, BY BYRON S. GOTTFRIED 
3   REM AND ALSO THE EXERCISE 8.32c AT PAGE 238 OF "PROGRAMMING WITH C" 
4   REM 1ST EDITION, BY BYRON S. GOTTFRIED 
100 REM HOME MORTGAGE COST WITH THE CONSTANT PAYMENT METHOD (CPM)
105 REM NOTE: THIS PROGRAM SHOULD BE USED ONLY FOR U.S. MORTGAGE CALCULATION
110 DEF FNA(I,A,N)=I*A*(((1+I)^N)/((1+I)^N-1))		' MONTHLY PAYMENT
120 DEF FNB(L,C,N,P)=L*((1+C)^N-(1+C)^P)/((1+C)^N-1)	' END-YEAR BALANCE
130 DEF FNI(X)=INT(X+0.5)				' ROUNDED INTEGER
200 PRINT "HOME MORTGAGE COST WITH THE CONSTANT PAYMENT METHOD"
210 PRINT
220 PRINT "TOTAL AMOUNT OF THE LOAN   =";
230 INPUT P
240 PRINT "ANNUAL INTEREST (%)        =";
250 INPUT I
260 I=I/100		' CONVERT PERCENT INTEREST TO DECIMAL INTEREST
270 PRINT "ANNUAL INTEREST            =";I
280 PRINT "MONTHLY INTEREST           =";I/12
290 PRINT "LOAN LENGTH (YEARS)        =";
300 INPUT Y
310 PRINT "NUMBER OF MONTHLY PAYMENTS =";Y*12
320 A=FNA(I/12,P,Y*12)*12
330 PRINT "MONTHLY PAYMENT            =";INT((A/12+0.005)*100)/100
340 PRINT "ANNUAL PAYMENT             =";INT((A+0.005)*100)/100
350 PRINT "TOTAL SUM                  =";Y*A
360 PRINT
370 PRINT "MORTGAGE TABLE"
380 PRINT
390 ' CALCULUS OF MONTHLY INTEREST PER PAYMENT DURING THE WHOLE PERIOD
400 PRINT "YEAR";TAB(9);"BEG.BAL";TAB(19);"TOT.PAY.";TAB(29)"INTEREST";
410 PRINT TAB(39);"PRINCIPLE";TAB(49);"END.BAL"
420 E=T=0	' END BALANCE AND PAYMENTS TOWARDS PRINCIPAL ARE NULL AT START
430 B=P		' FIRST BEGINNING YEAR BALANCE
440 FOR X=1 TO Y
450     E=FNB(P,I/12,Y*12,X*12) ' END YEAR BALANCE
460	T=B-E		' ANNUAL PAYMENT TOWARD PRINCIPAL RATE
470	PRINT X;TAB(8);FNI(B);TAB(18);FNI(A);TAB(28);FNI(A-T);
480	PRINT TAB(38);FNI(T);TAB(48);FNI(E)
490	B=E		' LAST END BALANCE BECOMES THE NEXT BEGINNING BALANCE
500 NEXT X
600 END

@Gottfried input data (from "Programming With C"):
loan $50,000  
annual interest 8% (case 1) and 8.5 (case 2)
period 25 years

To tell the truth, this program has not been built with Mr. Gottfried proposed
indications. The calculation failed because the principle T was calculated
as A-I = A-iB, but this does not lead the calculation to a zero balance.
So I had to look for the correct calculation of the remaining balance 
(contained in DEF FNB) and calculate T as the difference from the beginning 
balance and the ending balance for every period (lines 450-460).

Verified through the help of:
http://www.ultimatecalculators.com/mortgage_calculator.html
http://www.mtgprofessor.com/formulas.htm


First case: interest 8%

HOME MORTGAGE COST WITH THE CONSTANT PAYMENT METHOD

TOTAL AMOUNT OF THE LOAN   = ?50000
ANNUAL INTEREST (%)        = ?8
ANNUAL INTEREST            = 0.08 
MONTHLY INTEREST           = 6.66667E-3 
LOAN LENGTH (YEARS)        = ?25
NUMBER OF MONTHLY PAYMENTS = 300 
MONTHLY PAYMENT            = 385.91 
ANNUAL PAYMENT             = 4630.9 
TOTAL SUM                  = 115772. 

MORTGAGE TABLE

YEAR     BEG.BAL   TOT.PAY.  INTEREST  PRINCIPLE END.BAL
 1       50000     4631      3976      655       49345 
 2       49345     4631      3922      709       48637 
 3       48637     4631      3863      768       47869 
 4       47869     4631      3799      831       47037 
 5       47037     4631      3730      900       46137 
 6       46137     4631      3656      975       45162 
 7       45162     4631      3575      1056      44106 
 8       44106     4631      3487      1144      42962 
 9       42962     4631      3392      1239      41723 
 10      41723     4631      3289      1342      40382 
 11      40382     4631      3178      1453      38929 
 12      38929     4631      3057      1573      37355 
 13      37355     4631      2927      1704      35651 
 14      35651     4631      2785      1845      33806 
 15      33806     4631      2632      1999      31807 
 16      31807     4631      2466      2165      29643 
 17      29643     4631      2287      2344      27298 
 18      27298     4631      2092      2539      24760 
 19      24760     4631      1881      2749      22010 
 20      22010     4631      1653      2978      19032 
 21      19032     4631      1406      3225      15808 
 22      15808     4631      1138      3493      12315 
 23      12315     4631      849       3782      8533 
 24      8533      4631      535       4096      4436 
 25      4436      4631      195       4436      0 


Second case: interest 8.5%

HOME MORTGAGE COST WITH THE CONSTANT PAYMENT METHOD

TOTAL AMOUNT OF THE LOAN   = ?50000
ANNUAL INTEREST (%)        = ?8.5
ANNUAL INTEREST            = 0.085 
MONTHLY INTEREST           = 7.08333E-3 
LOAN LENGTH (YEARS)        = ?25
NUMBER OF MONTHLY PAYMENTS = 300 
MONTHLY PAYMENT            = 402.61 
ANNUAL PAYMENT             = 4831.36 
TOTAL SUM                  = 120784. 

MORTGAGE TABLE

YEAR     BEG.BAL   TOT.PAY.  INTEREST  PRINCIPLE END.BAL
 1       50000     4831      4227      605       49395 
 2       49395     4831      4173      658       48737 
 3       48737     4831      4115      716       48021 
 4       48021     4831      4052      779       47242 
 5       47242     4831      3983      848       46393 
 6       46393     4831      3908      923       45470 
 7       45470     4831      3826      1005      44465 
 8       44465     4831      3738      1094      43371 
 9       43371     4831      3641      1190      42181 
 10      42181     4831      3536      1296      40885 
 11      40885     4831      3421      1410      39475 
 12      39475     4831      3296      1535      37940 
 13      37940     4831      3161      1671      36270 
 14      36270     4831      3013      1818      34451 
 15      34451     4831      2852      1979      32473 
 16      32473     4831      2678      2154      30319 
 17      30319     4831      2487      2344      27975 
 18      27975     4831      2280      2551      25423 
 19      25423     4831      2054      2777      22646 
 20      22646     4831      1809      3022      19624 
 21      19624     4831      1542      3290      16334 
 22      16334     4831      1251      3580      12754 
 23      12754     4831      935       3897      8857 
 24      8857      4831      590       4241      4616 
 25      4616      4831      215       4616      0 

Answer: the difference of 0.5% between the two cases (8% and 8.5%) leads to the 
following conclusions:

The monthly payment grows imperceptibly: from 386 to 403 dollars, but:
- the annual rate grows from $4631 to $4831 (+$200)
- the total returned sum increases from $115772 to $120784 (+$5012)
- the total interest sum grows from $65772 to $70784 (56.81% to 58.60%)

I'm not involved with lending institutions; I fortunately have never met such 
people; maybe Americans are used to this type of loan (115772 dollars given
back for a 50000 dollars loan!), but in Italy we call these people with other
not quite gentle names.

In any case, dear Mr. Gottfried, I don't know if these are the correct answers
to the problem, but I had much satisfaction in creating this program.
Cheers.

-- Antonio

