1   REM THIS PROGRAM IS THE EXERCISE 5.53l AT PAGE 108 OF THE ITALIAN VERSION
2   REM OF "PROGRAMMING IN BASIC" 1ST EDITION, BY BYRON S. GOTTFRIED 
10  REM TRAPEZIUM RULE FOR APPROXIMATING THE DEFINITE INTEGRAL
50  REM FUNCTION (CUSTOMIZE)
60  DEF FNF(X)=X^3
100 REM ASK FOR LIMITS AND POINTS
110 PRINT "LEFT LIMIT A=";
120 INPUT A
130 PRINT "RIGHT LIMIT B=";
140 INPUT B
145 PRINT "TYPE 0 TO STOP PROCESS."
150 S=0
160 PRINT "HOW MANY POINTS";
170 INPUT N
180 IF N<=0 THEN 300
190 W=(B-A)/(N-1)	' CALCULATE INTERVAL CONSTANT WIDTH
200 REM CALCULATE
210 FOR X=A TO B-W/2 STEP W
220	S=S+FNF(X+W/2)*W
230 NEXT X
240 PRINT USING "AREA =######.#######",S
250 REM ASK FOR NEW NUMBER OF POINTS
260 GOTO 150
300 END


@ The exercise proposed by prof. Gottfried asked for N=16, 61 and 301 points
in the interval 1.0-4.0 (thus respectively 15, 60 and 300 intervals), giving 
also the exact solution, A=63.75; I had to insert a PRINT USING to show the 
full precision decimals of the calculated area.

The following is the output of TRAPEZ for the proposed points numbers, with the
addition of N=20001, which returns the correct result (areas start to become 
infinitesimal for the proposed interval, and error negligible).


TRAPEZ        10:59         16-NOV-14    



LEFT LIMIT A= ?1
RIGHT LIMIT B= ?4
TYPE 0 TO STOP PROCESS.
HOW MANY POINTS ?16
AREA =    63.6750000
HOW MANY POINTS ?61
AREA =    63.7453125
HOW MANY POINTS ?301
AREA =    63.7498125
HOW MANY POINTS ?10001
AREA =    63.7499998
HOW MANY POINTS ?20001
AREA =    63.7500000
HOW MANY POINTS ?0



TIME:  2.33 SECS.


This program can be customizable in line 20, where you can put your own 
function. For new limits A and B, rerun the program.

It's a useful notice observing here that the Simpson rule achieves the exact
solution for the function y=x^3 in only 3 steps (see SIMPSN.BAS), though 
roundoff errors are in action, here.
